/* Esercizio 1
* Scrivere un programma che legga da tastiera una sequenza di n interi dis-
* tinti e li inserisca in un albero binario di ricerca (senza ribilanciamento).
* Il programma entra poi in un ciclo infinito nel quale legge un intero i da
* tastiera e lo cerca nell’albero. Se i si trova nell’albero stampa la profondità                                                                   
* alla quale l’elemento si trova (contando da 0) altrimenti stampa NO.
* L’input è formattato nel seguente modo: nella prima riga si trova la lunghezza
* della sequenza e nelle successive si trovano gli interi che compongono la se-
* quenza.
*/


#include <stdio.h>
#include <stdlib.h>

struct Nodo{

int key;
struct Nodo* left;
struct Nodo* right;

};

typedef struct Nodo* Tree;

void insert(Tree *t, int k){

 // crea il nodo foglia da inserire contenente la chiave
 struct Nodo* e = malloc(sizeof(struct Nodo));
 e->key = k;
 e->left = e->right = NULL;  

 struct Nodo* p;
 struct Nodo* x =  *t;

 // se l'albero è vuoto imposta e come radice dell'albero
 if (x == NULL) {
   *t = e;
   return;
 }

 // altrimenti cerca la posizione della foglia nell'albero 
 while (x != NULL){ 

   p = x;
   if (x->key < k) x = x->right;
   else x = x->left;
 }

 // ora p punta al padre del nuovo elemento da inserire in t
 // quindi si procede a linkare p ed e
 
 if (p->key < k) p->right = e;
 else p->left = e;

}


// cerca una chiave k nell'albero t e restituisce la profondità alla quale si trova
// oppure 0 se la chiave non è presente in t 

int search(Tree t, int k){

struct Nodo* n= t;
int depth = 0;

while (n != NULL){
 depth++;
 if (n->key < k) n = n->left;
 else if (n->key == k) return depth;
 else n = n->right;
}

return 0;
}


int main() {

int numchiavi;
int k,i;
Tree t= NULL;

// inserisce tutte le chiavi in t
scanf("%d", &numchiavi);
for(i=0; i < numchiavi; i++){
    scanf("%d",&k);
    insert(&t, k);
 }

// ora legge una serie illimitata di interi e li cerca in t
// stampando la profondità di ciascuno di essi.

int depth;
while (1){
      scanf("%d",&k);
      if (depth = search(t,k))
        printf("%d\n",depth);
     else printf("NO\n");
 }

return 0;
}

